<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.xml.config;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.io.ByteArrayInputStream;<a name="line.36"></a>
<FONT color="green">037</FONT>    import java.io.ByteArrayOutputStream;<a name="line.37"></a>
<FONT color="green">038</FONT>    import java.io.File;<a name="line.38"></a>
<FONT color="green">039</FONT>    import java.io.InputStream;<a name="line.39"></a>
<FONT color="green">040</FONT>    import java.io.OutputStream;<a name="line.40"></a>
<FONT color="green">041</FONT>    import java.io.PrintStream;<a name="line.41"></a>
<FONT color="green">042</FONT>    import java.io.Reader;<a name="line.42"></a>
<FONT color="green">043</FONT>    import java.io.Writer;<a name="line.43"></a>
<FONT color="green">044</FONT>    import java.text.DateFormat;<a name="line.44"></a>
<FONT color="green">045</FONT>    import java.text.SimpleDateFormat;<a name="line.45"></a>
<FONT color="green">046</FONT>    import java.util.ArrayList;<a name="line.46"></a>
<FONT color="green">047</FONT>    import java.util.Collections;<a name="line.47"></a>
<FONT color="green">048</FONT>    import java.util.Date;<a name="line.48"></a>
<FONT color="green">049</FONT>    import java.util.Iterator;<a name="line.49"></a>
<FONT color="green">050</FONT>    import java.util.List;<a name="line.50"></a>
<FONT color="green">051</FONT>    import java.util.Properties;<a name="line.51"></a>
<FONT color="green">052</FONT>    import java.util.logging.LogManager;<a name="line.52"></a>
<FONT color="green">053</FONT>    import java.util.logging.Logger;<a name="line.53"></a>
<FONT color="green">054</FONT>    <a name="line.54"></a>
<FONT color="green">055</FONT>    import org.dom4j.Attribute;<a name="line.55"></a>
<FONT color="green">056</FONT>    import org.dom4j.Document;<a name="line.56"></a>
<FONT color="green">057</FONT>    import org.dom4j.DocumentException;<a name="line.57"></a>
<FONT color="green">058</FONT>    import org.dom4j.DocumentHelper;<a name="line.58"></a>
<FONT color="green">059</FONT>    import org.dom4j.Element;<a name="line.59"></a>
<FONT color="green">060</FONT>    import org.dom4j.io.SAXReader;<a name="line.60"></a>
<FONT color="green">061</FONT>    <a name="line.61"></a>
<FONT color="green">062</FONT>    /**<a name="line.62"></a>
<FONT color="green">063</FONT>     * The &lt;tt&gt;XmlConfig&lt;/tt&gt; class is a generic xml configuration reader, <a name="line.63"></a>
<FONT color="green">064</FONT>     * supporting features like referred configuration blocks, accessing system<a name="line.64"></a>
<FONT color="green">065</FONT>     * property values and program invocation parameters (args of the main method).<a name="line.65"></a>
<FONT color="green">066</FONT>     */<a name="line.66"></a>
<FONT color="green">067</FONT>    public class XmlConfig {<a name="line.67"></a>
<FONT color="green">068</FONT>                    <a name="line.68"></a>
<FONT color="green">069</FONT>            public static final String NO_APP_NAME = "main";<a name="line.69"></a>
<FONT color="green">070</FONT>            <a name="line.70"></a>
<FONT color="green">071</FONT>            /**<a name="line.71"></a>
<FONT color="green">072</FONT>             * Predefined and recognized xml elements<a name="line.72"></a>
<FONT color="green">073</FONT>             * &lt;p&gt;<a name="line.73"></a>
<FONT color="green">074</FONT>             * In xml, the element names equal the enum constant names.<a name="line.74"></a>
<FONT color="green">075</FONT>             */<a name="line.75"></a>
<FONT color="green">076</FONT>            public static enum XmlElement implements XmlNode {<a name="line.76"></a>
<FONT color="green">077</FONT>                    application, referable, config_list, config, arg, logging, property, usage, line;<a name="line.77"></a>
<FONT color="green">078</FONT>                    /** The element name in xml, same as enum constant name*/<a name="line.78"></a>
<FONT color="green">079</FONT>                    public String getXmlName() {return name().replace('_', '-');}<a name="line.79"></a>
<FONT color="green">080</FONT>            }<a name="line.80"></a>
<FONT color="green">081</FONT>            /**<a name="line.81"></a>
<FONT color="green">082</FONT>             * Predefined and recognized xml attributes.<a name="line.82"></a>
<FONT color="green">083</FONT>             * &lt;p&gt;<a name="line.83"></a>
<FONT color="green">084</FONT>             * In xml, the attribute names equal the enum constant names, only def<a name="line.84"></a>
<FONT color="green">085</FONT>             * is called "default" in xml (default cannot be a constant name in java). <a name="line.85"></a>
<FONT color="green">086</FONT>             */<a name="line.86"></a>
<FONT color="green">087</FONT>            public static enum XmlAttribute implements XmlNode {<a name="line.87"></a>
<FONT color="green">088</FONT>                    def, name, ref, value;<a name="line.88"></a>
<FONT color="green">089</FONT>                    /** The attribute name in xml, same as enum constant name, but "default" for def*/<a name="line.89"></a>
<FONT color="green">090</FONT>                    public String getXmlName() {<a name="line.90"></a>
<FONT color="green">091</FONT>                            return this == def ? "default" : name();<a name="line.91"></a>
<FONT color="green">092</FONT>                    }<a name="line.92"></a>
<FONT color="green">093</FONT>            }<a name="line.93"></a>
<FONT color="green">094</FONT>            /**<a name="line.94"></a>
<FONT color="green">095</FONT>             * Key elements be used in {...} brackets, will be resolved by the <a name="line.95"></a>
<FONT color="green">096</FONT>             * corresponding content. Can be used to address the working directory,<a name="line.96"></a>
<FONT color="green">097</FONT>             * application name, system properties, command line arguments/options<a name="line.97"></a>
<FONT color="green">098</FONT>             * respectively.<a name="line.98"></a>
<FONT color="green">099</FONT>             * &lt;p&gt;<a name="line.99"></a>
<FONT color="green">100</FONT>             * In xml, the names of the keys equal the enum constant names, but <a name="line.100"></a>
<FONT color="green">101</FONT>             * replacing _ with -. <a name="line.101"></a>
<FONT color="green">102</FONT>             */<a name="line.102"></a>
<FONT color="green">103</FONT>            public static enum ResolveKey{<a name="line.103"></a>
<FONT color="green">104</FONT>                    work_dir, app_name, sys_prop, date, time, now, arg, opt, list;<a name="line.104"></a>
<FONT color="green">105</FONT>                    /** The key name in xml, same as enum constant name, but _ replaced by -*/<a name="line.105"></a>
<FONT color="green">106</FONT>                    public String xmlName() {<a name="line.106"></a>
<FONT color="green">107</FONT>                            return name().replaceAll("_", "-");<a name="line.107"></a>
<FONT color="green">108</FONT>                    }<a name="line.108"></a>
<FONT color="green">109</FONT>                    public String resolve(Attribute att, String path, String value, XmlConfig config) throws XmlConfigException {<a name="line.109"></a>
<FONT color="green">110</FONT>                            switch (this) {<a name="line.110"></a>
<FONT color="green">111</FONT>                                    case work_dir:  //{work-dir}<a name="line.111"></a>
<FONT color="green">112</FONT>                                            return new File(".").getAbsolutePath();<a name="line.112"></a>
<FONT color="green">113</FONT>                                    case app_name:  //{app-name}<a name="line.113"></a>
<FONT color="green">114</FONT>                                            return config.mAppName;<a name="line.114"></a>
<FONT color="green">115</FONT>                                    case date:<a name="line.115"></a>
<FONT color="green">116</FONT>                                            return DATE_FORMAT.format(config.mTimestamp);<a name="line.116"></a>
<FONT color="green">117</FONT>                                    case time:<a name="line.117"></a>
<FONT color="green">118</FONT>                                            return TIME_FORMAT.format(config.mTimestamp);<a name="line.118"></a>
<FONT color="green">119</FONT>                                    case now:<a name="line.119"></a>
<FONT color="green">120</FONT>                                            return TIMESTAMP_FORMAT.format(config.mTimestamp);<a name="line.120"></a>
<FONT color="green">121</FONT>                                    case sys_prop:  //{sys-prop:user.home} or {sys-prop:myprop:mydefault}<a name="line.121"></a>
<FONT color="green">122</FONT>                                            String[] parts  = value.split(":");<a name="line.122"></a>
<FONT color="green">123</FONT>                                            if (parts.length &lt; 2) {<a name="line.123"></a>
<FONT color="green">124</FONT>                                                    throw new XmlConfigException("property name missing for '" + xmlName() + "' for attribute \"" + att.getName() + "=" + att.getValue() + "\"", path);                                             <a name="line.124"></a>
<FONT color="green">125</FONT>                                            }<a name="line.125"></a>
<FONT color="green">126</FONT>                                            String propName = parts[1];<a name="line.126"></a>
<FONT color="green">127</FONT>                                            String propDef  = parts.length &lt; 3 ? "" : parts[2];<a name="line.127"></a>
<FONT color="green">128</FONT>                                            return System.getProperty(propName, propDef);<a name="line.128"></a>
<FONT color="green">129</FONT>                                    case arg:               //{1} for first argument, {2}, ...<a name="line.129"></a>
<FONT color="green">130</FONT>                                    {<a name="line.130"></a>
<FONT color="green">131</FONT>                                            String defValue = null;<a name="line.131"></a>
<FONT color="green">132</FONT>                                            int defIndex = value.indexOf(':');<a name="line.132"></a>
<FONT color="green">133</FONT>                                            if (defIndex != -1) {<a name="line.133"></a>
<FONT color="green">134</FONT>                                                    defValue        = value.substring(defIndex + 1);<a name="line.134"></a>
<FONT color="green">135</FONT>                                                    value           = value.substring(0, defIndex);<a name="line.135"></a>
<FONT color="green">136</FONT>                                            }<a name="line.136"></a>
<FONT color="green">137</FONT>                                            int argLen = 0;<a name="line.137"></a>
<FONT color="green">138</FONT>                                            while (argLen &lt; config.mArgs.length) {<a name="line.138"></a>
<FONT color="green">139</FONT>                                                    if (config.mArgs[argLen].startsWith("-")) {<a name="line.139"></a>
<FONT color="green">140</FONT>                                                            break;<a name="line.140"></a>
<FONT color="green">141</FONT>                                                    }<a name="line.141"></a>
<FONT color="green">142</FONT>                                                    argLen++;<a name="line.142"></a>
<FONT color="green">143</FONT>                                            }<a name="line.143"></a>
<FONT color="green">144</FONT>                                            int index = Integer.parseInt(value) - 1;//should not fail<a name="line.144"></a>
<FONT color="green">145</FONT>                                            if (index &gt;= 0 &amp;&amp; index &lt; argLen) return config.mArgs[index];<a name="line.145"></a>
<FONT color="green">146</FONT>                                            if (defIndex != -1) return defValue;<a name="line.146"></a>
<FONT color="green">147</FONT>                                            throw new XmlArgException(index, "cannot resolve arg[" + (index + 1) + "] for attribute \"" + att.getName() + "=" + att.getValue() + "\"", path);<a name="line.147"></a>
<FONT color="green">148</FONT>                                    }<a name="line.148"></a>
<FONT color="green">149</FONT>                                    case opt:               //{-opt[1]} for an option called opt, the first argument after it, {-opt[2]} for the second ... <a name="line.149"></a>
<FONT color="green">150</FONT>                                    {<a name="line.150"></a>
<FONT color="green">151</FONT>                                            String defValue = null;<a name="line.151"></a>
<FONT color="green">152</FONT>                                            int defIndex = value.indexOf(':');<a name="line.152"></a>
<FONT color="green">153</FONT>                                            if (defIndex != -1) {<a name="line.153"></a>
<FONT color="green">154</FONT>                                                    defValue        = value.substring(defIndex + 1);<a name="line.154"></a>
<FONT color="green">155</FONT>                                                    value           = value.substring(0, defIndex);<a name="line.155"></a>
<FONT color="green">156</FONT>                                            }<a name="line.156"></a>
<FONT color="green">157</FONT>                                            int sbStart = value.indexOf('[', 1);<a name="line.157"></a>
<FONT color="green">158</FONT>                                            if (sbStart == -1) {<a name="line.158"></a>
<FONT color="green">159</FONT>                                                    throw new XmlConfigException("opening [ missing for option argument for attribute \"" + att.getName() + "=" + att.getValue() + "\"", path);                                             <a name="line.159"></a>
<FONT color="green">160</FONT>                                            }<a name="line.160"></a>
<FONT color="green">161</FONT>                                            int sbEnd       = value.indexOf(']', sbStart + 1);<a name="line.161"></a>
<FONT color="green">162</FONT>                                            if (sbEnd == -1) {<a name="line.162"></a>
<FONT color="green">163</FONT>                                                    throw new XmlConfigException("closing ] missing for option argument for attribute \"" + att.getName() + "=" + att.getValue() + "\"", path);                                             <a name="line.163"></a>
<FONT color="green">164</FONT>                                            }                                       <a name="line.164"></a>
<FONT color="green">165</FONT>                                            String optName  = value.substring(1, sbStart);<a name="line.165"></a>
<FONT color="green">166</FONT>                                            int optIndex    = -1;<a name="line.166"></a>
<FONT color="green">167</FONT>                                            for (int i = 0; i &lt; config.mArgs.length; i++) {<a name="line.167"></a>
<FONT color="green">168</FONT>                                                    if (config.mArgs[i].equals("-" + optName)) optIndex = i;<a name="line.168"></a>
<FONT color="green">169</FONT>                                            }<a name="line.169"></a>
<FONT color="green">170</FONT>                                            if (optIndex == -1) {<a name="line.170"></a>
<FONT color="green">171</FONT>                                                    if (defIndex != -1) return defValue;<a name="line.171"></a>
<FONT color="green">172</FONT>                                                    throw new XmlArgException(optName, "no option '" + optName + "' found in argument list for attribute \"" + att.getName() + "=" + att.getValue() + "\"", path);                                          <a name="line.172"></a>
<FONT color="green">173</FONT>                                            }<a name="line.173"></a>
<FONT color="green">174</FONT>                                            int optArgIndex = -1;<a name="line.174"></a>
<FONT color="green">175</FONT>                                            try {<a name="line.175"></a>
<FONT color="green">176</FONT>                                                    optArgIndex = Integer.parseInt(value.substring(sbStart + 1, sbEnd));<a name="line.176"></a>
<FONT color="green">177</FONT>                                            }<a name="line.177"></a>
<FONT color="green">178</FONT>                                            catch (Exception ex) {}<a name="line.178"></a>
<FONT color="green">179</FONT>                                            if (optArgIndex == -1) {<a name="line.179"></a>
<FONT color="green">180</FONT>                                                    throw new XmlConfigException("cannot parse option argument index for option '" + optName + "' for attribute \"" + att.getName() + "=" + att.getValue() + "\"", path);                                           <a name="line.180"></a>
<FONT color="green">181</FONT>                                            }<a name="line.181"></a>
<FONT color="green">182</FONT>                                            int index = optIndex + optArgIndex;<a name="line.182"></a>
<FONT color="green">183</FONT>                                            int optLen = optIndex + 1;<a name="line.183"></a>
<FONT color="green">184</FONT>                                            while (optLen &lt; config.mArgs.length) {<a name="line.184"></a>
<FONT color="green">185</FONT>                                                    if (config.mArgs[optLen].startsWith("-")) {<a name="line.185"></a>
<FONT color="green">186</FONT>                                                            break;<a name="line.186"></a>
<FONT color="green">187</FONT>                                                    }<a name="line.187"></a>
<FONT color="green">188</FONT>                                                    optLen++;<a name="line.188"></a>
<FONT color="green">189</FONT>                                            }                                       <a name="line.189"></a>
<FONT color="green">190</FONT>                                            if (index &gt;= 0 &amp;&amp; index &lt; optLen) return config.mArgs[index];<a name="line.190"></a>
<FONT color="green">191</FONT>                                            if (defIndex != -1) return defValue;<a name="line.191"></a>
<FONT color="green">192</FONT>                                            throw new XmlArgException(optName, optArgIndex, "cannot resolve arg[" + (index + 1) + "] for option argument '" + optName + "[" + optArgIndex + "]'" + " for attribute \"" + att.getName() + "=" + att.getValue() + "\"", path);<a name="line.192"></a>
<FONT color="green">193</FONT>                                    }<a name="line.193"></a>
<FONT color="green">194</FONT>                                    case list:              //{-list[*,*]} for an option called list, returned as comma separated string <a name="line.194"></a>
<FONT color="green">195</FONT>                                    {<a name="line.195"></a>
<FONT color="green">196</FONT>                                            String defValue = null;<a name="line.196"></a>
<FONT color="green">197</FONT>                                            int defIndex = value.indexOf(':');<a name="line.197"></a>
<FONT color="green">198</FONT>                                            if (defIndex != -1) {<a name="line.198"></a>
<FONT color="green">199</FONT>                                                    defValue        = value.substring(defIndex + 1);<a name="line.199"></a>
<FONT color="green">200</FONT>                                                    value           = value.substring(0, defIndex);<a name="line.200"></a>
<FONT color="green">201</FONT>                                            }<a name="line.201"></a>
<FONT color="green">202</FONT>                                            int sbStart = value.indexOf('[', 1);<a name="line.202"></a>
<FONT color="green">203</FONT>                                            if (sbStart == -1) {<a name="line.203"></a>
<FONT color="green">204</FONT>                                                    throw new XmlConfigException("opening [ missing for list argument for attribute \"" + att.getName() + "=" + att.getValue() + "\"", path);                                               <a name="line.204"></a>
<FONT color="green">205</FONT>                                            }<a name="line.205"></a>
<FONT color="green">206</FONT>                                            int sbEnd       = value.indexOf(']', sbStart + 1);<a name="line.206"></a>
<FONT color="green">207</FONT>                                            if (sbEnd == -1) {<a name="line.207"></a>
<FONT color="green">208</FONT>                                                    throw new XmlConfigException("closing ] missing for list argument for attribute \"" + att.getName() + "=" + att.getValue() + "\"", path);                                               <a name="line.208"></a>
<FONT color="green">209</FONT>                                            }                                       <a name="line.209"></a>
<FONT color="green">210</FONT>                                            String lstName  = value.substring(1, sbStart);<a name="line.210"></a>
<FONT color="green">211</FONT>                                            String lstFill  = value.substring(sbStart + 2, sbEnd - 1);//ommit the leading and tailing *<a name="line.211"></a>
<FONT color="green">212</FONT>                                            int lstStart    = -1;<a name="line.212"></a>
<FONT color="green">213</FONT>                                            for (int i = 0; i &lt; config.mArgs.length; i++) {<a name="line.213"></a>
<FONT color="green">214</FONT>                                                    if (config.mArgs[i].equals("-" + lstName)) lstStart = i;<a name="line.214"></a>
<FONT color="green">215</FONT>                                            }<a name="line.215"></a>
<FONT color="green">216</FONT>                                            int lstEnd = lstStart + 1;<a name="line.216"></a>
<FONT color="green">217</FONT>                                            if (lstStart != -1) {<a name="line.217"></a>
<FONT color="green">218</FONT>                                                    for (int i = lstStart + 1; i &lt; config.mArgs.length; i++) {<a name="line.218"></a>
<FONT color="green">219</FONT>                                                            if (config.mArgs[i].startsWith("-")) {<a name="line.219"></a>
<FONT color="green">220</FONT>                                                                    break;<a name="line.220"></a>
<FONT color="green">221</FONT>                                                            }<a name="line.221"></a>
<FONT color="green">222</FONT>                                                            else {<a name="line.222"></a>
<FONT color="green">223</FONT>                                                                    lstEnd++;<a name="line.223"></a>
<FONT color="green">224</FONT>                                                            }<a name="line.224"></a>
<FONT color="green">225</FONT>                                                    }<a name="line.225"></a>
<FONT color="green">226</FONT>                                            }<a name="line.226"></a>
<FONT color="green">227</FONT>                                            if (lstStart + 1 &gt;= lstEnd) {<a name="line.227"></a>
<FONT color="green">228</FONT>                                                    if (defIndex != -1) return defValue;<a name="line.228"></a>
<FONT color="green">229</FONT>                                                    return "";                                                                                              <a name="line.229"></a>
<FONT color="green">230</FONT>                                            }<a name="line.230"></a>
<FONT color="green">231</FONT>                                            final StringBuilder sb = new StringBuilder();<a name="line.231"></a>
<FONT color="green">232</FONT>                                            for (int i = lstStart + 1; i &lt; lstEnd; i++) {<a name="line.232"></a>
<FONT color="green">233</FONT>                                                    if (sb.length() &gt; 0) sb.append(lstFill);<a name="line.233"></a>
<FONT color="green">234</FONT>                                                    sb.append(config.mArgs[i]);<a name="line.234"></a>
<FONT color="green">235</FONT>                                            }<a name="line.235"></a>
<FONT color="green">236</FONT>                                            return sb.toString();<a name="line.236"></a>
<FONT color="green">237</FONT>                                    }<a name="line.237"></a>
<FONT color="green">238</FONT>                                    default:<a name="line.238"></a>
<FONT color="green">239</FONT>                                            //should not happen<a name="line.239"></a>
<FONT color="green">240</FONT>                                            throw new XmlConfigException("cannot resolve '" + xmlName() + "' for attribute \"" + att.getName() + "=" + att.getValue() + "\"", path);                                        <a name="line.240"></a>
<FONT color="green">241</FONT>                            }<a name="line.241"></a>
<FONT color="green">242</FONT>                    }<a name="line.242"></a>
<FONT color="green">243</FONT>                    public boolean matches(String value) {<a name="line.243"></a>
<FONT color="green">244</FONT>                            if (this == arg || this == opt || this == list) {<a name="line.244"></a>
<FONT color="green">245</FONT>                                    //arg, opt and list can have default values<a name="line.245"></a>
<FONT color="green">246</FONT>                                    //arg: {1:mydefault}<a name="line.246"></a>
<FONT color="green">247</FONT>                                    //opt: {-myopt[1]:mydefault}<a name="line.247"></a>
<FONT color="green">248</FONT>                                    //list: {-mylist[*,*]:mydefault}                list returned as comma separated string<a name="line.248"></a>
<FONT color="green">249</FONT>                                    int ind = value.indexOf(':');<a name="line.249"></a>
<FONT color="green">250</FONT>                                    if (ind != -1) value = value.substring(0, ind);<a name="line.250"></a>
<FONT color="green">251</FONT>                                    if (this == arg) {<a name="line.251"></a>
<FONT color="green">252</FONT>                                            return isInt(value);<a name="line.252"></a>
<FONT color="green">253</FONT>                                    }<a name="line.253"></a>
<FONT color="green">254</FONT>                                    else {<a name="line.254"></a>
<FONT color="green">255</FONT>                                            if (!value.startsWith("-")) return false;<a name="line.255"></a>
<FONT color="green">256</FONT>                                            final int start = value.indexOf('[');<a name="line.256"></a>
<FONT color="green">257</FONT>                                            final int end   = value.indexOf(']', start + 1);<a name="line.257"></a>
<FONT color="green">258</FONT>                                            if (start &lt; 0 || end &lt; 0) {<a name="line.258"></a>
<FONT color="green">259</FONT>                                                    return false;<a name="line.259"></a>
<FONT color="green">260</FONT>                                            }<a name="line.260"></a>
<FONT color="green">261</FONT>                                            value = value.substring(start + 1, end);<a name="line.261"></a>
<FONT color="green">262</FONT>                                            if (this == opt) {<a name="line.262"></a>
<FONT color="green">263</FONT>                                                    return isInt(value);<a name="line.263"></a>
<FONT color="green">264</FONT>                                            }<a name="line.264"></a>
<FONT color="green">265</FONT>                                            else if (this == list) {<a name="line.265"></a>
<FONT color="green">266</FONT>                                                    return value.startsWith("*") &amp;&amp; value.endsWith("*") &amp;&amp;<a name="line.266"></a>
<FONT color="green">267</FONT>                                                    value.length() &gt;= 2;<a name="line.267"></a>
<FONT color="green">268</FONT>                                            }<a name="line.268"></a>
<FONT color="green">269</FONT>                                            else throw new InternalError();                                 <a name="line.269"></a>
<FONT color="green">270</FONT>                                    }<a name="line.270"></a>
<FONT color="green">271</FONT>                            }<a name="line.271"></a>
<FONT color="green">272</FONT>                            String xmlName = xmlName();<a name="line.272"></a>
<FONT color="green">273</FONT>                            return this == sys_prop ? value.startsWith(xmlName) : value.equals(xmlName);<a name="line.273"></a>
<FONT color="green">274</FONT>                    }<a name="line.274"></a>
<FONT color="green">275</FONT>            }<a name="line.275"></a>
<FONT color="green">276</FONT>            <a name="line.276"></a>
<FONT color="green">277</FONT>            private static boolean isInt(String s) {<a name="line.277"></a>
<FONT color="green">278</FONT>                    try {<a name="line.278"></a>
<FONT color="green">279</FONT>                            Integer.parseInt(s);<a name="line.279"></a>
<FONT color="green">280</FONT>                            return true;<a name="line.280"></a>
<FONT color="green">281</FONT>                    }<a name="line.281"></a>
<FONT color="green">282</FONT>                    catch (NumberFormatException ex) {<a name="line.282"></a>
<FONT color="green">283</FONT>                            return false;<a name="line.283"></a>
<FONT color="green">284</FONT>                    }               <a name="line.284"></a>
<FONT color="green">285</FONT>            }<a name="line.285"></a>
<FONT color="green">286</FONT>            <a name="line.286"></a>
<FONT color="green">287</FONT>            private static final DateFormat DATE_FORMAT             = new SimpleDateFormat("yyyy-MM-dd");<a name="line.287"></a>
<FONT color="green">288</FONT>            private static final DateFormat TIME_FORMAT             = new SimpleDateFormat("HH:mm:ss.SSS");<a name="line.288"></a>
<FONT color="green">289</FONT>            private static final DateFormat TIMESTAMP_FORMAT        = new SimpleDateFormat("yyyy-MM-dd_HH:mm:ss.SSS");<a name="line.289"></a>
<FONT color="green">290</FONT>            <a name="line.290"></a>
<FONT color="green">291</FONT>            protected final Document        mDocument;<a name="line.291"></a>
<FONT color="green">292</FONT>            protected final String[]        mArgs;<a name="line.292"></a>
<FONT color="green">293</FONT>            protected final Date            mTimestamp = new Date();<a name="line.293"></a>
<FONT color="green">294</FONT>    <a name="line.294"></a>
<FONT color="green">295</FONT>            private String  mAppName;<a name="line.295"></a>
<FONT color="green">296</FONT>            <a name="line.296"></a>
<FONT color="green">297</FONT>            protected XmlConfig(String appName, Document xmlDoc) {<a name="line.297"></a>
<FONT color="green">298</FONT>                    this(appName, xmlDoc, null);<a name="line.298"></a>
<FONT color="green">299</FONT>            }<a name="line.299"></a>
<FONT color="green">300</FONT>            protected XmlConfig(String appName, Document xmlDoc, String[] args) {<a name="line.300"></a>
<FONT color="green">301</FONT>                    mAppName        = appName;<a name="line.301"></a>
<FONT color="green">302</FONT>                    mDocument       = xmlDoc;<a name="line.302"></a>
<FONT color="green">303</FONT>                    mArgs           = args == null ? new String[] {} : args;<a name="line.303"></a>
<FONT color="green">304</FONT>            }<a name="line.304"></a>
<FONT color="green">305</FONT>            <a name="line.305"></a>
<FONT color="green">306</FONT>            public static XmlConfig getXmlConfig(File xmlFile) throws DocumentException {<a name="line.306"></a>
<FONT color="green">307</FONT>                    return getXmlConfig(NO_APP_NAME, xmlFile);<a name="line.307"></a>
<FONT color="green">308</FONT>            }<a name="line.308"></a>
<FONT color="green">309</FONT>            public static XmlConfig getXmlConfig(Reader xmlFile) throws DocumentException {<a name="line.309"></a>
<FONT color="green">310</FONT>                    return getXmlConfig(NO_APP_NAME, xmlFile);<a name="line.310"></a>
<FONT color="green">311</FONT>            }<a name="line.311"></a>
<FONT color="green">312</FONT>            public static XmlConfig getXmlConfig(InputStream xmlFile) throws DocumentException {<a name="line.312"></a>
<FONT color="green">313</FONT>                    return getXmlConfig(NO_APP_NAME, xmlFile);<a name="line.313"></a>
<FONT color="green">314</FONT>            }<a name="line.314"></a>
<FONT color="green">315</FONT>            public static XmlConfig getXmlConfig(Document xmlDocument) throws DocumentException {<a name="line.315"></a>
<FONT color="green">316</FONT>                    return getXmlConfig(NO_APP_NAME, xmlDocument);<a name="line.316"></a>
<FONT color="green">317</FONT>            }<a name="line.317"></a>
<FONT color="green">318</FONT>            public static XmlConfig getXmlConfig(String appName, File xmlFile) throws DocumentException {<a name="line.318"></a>
<FONT color="green">319</FONT>                    return getXmlConfig(appName, new SAXReader().read(xmlFile));<a name="line.319"></a>
<FONT color="green">320</FONT>            }<a name="line.320"></a>
<FONT color="green">321</FONT>            public static XmlConfig getXmlConfig(String appName, Reader xmlFile) throws DocumentException {<a name="line.321"></a>
<FONT color="green">322</FONT>                    return getXmlConfig(appName, new SAXReader().read(xmlFile));<a name="line.322"></a>
<FONT color="green">323</FONT>            }<a name="line.323"></a>
<FONT color="green">324</FONT>            public static XmlConfig getXmlConfig(String appName, InputStream xmlFile) throws DocumentException {<a name="line.324"></a>
<FONT color="green">325</FONT>                    return getXmlConfig(appName, new SAXReader().read(xmlFile));<a name="line.325"></a>
<FONT color="green">326</FONT>            }<a name="line.326"></a>
<FONT color="green">327</FONT>            public static XmlConfig getXmlConfig(String appName, Document xmlDocument) throws DocumentException {<a name="line.327"></a>
<FONT color="green">328</FONT>                    return new XmlConfig(appName, xmlDocument);<a name="line.328"></a>
<FONT color="green">329</FONT>            }<a name="line.329"></a>
<FONT color="green">330</FONT>            public static XmlConfig getXmlConfig(File xmlFile, String[] args) throws DocumentException {<a name="line.330"></a>
<FONT color="green">331</FONT>                    return getXmlConfig(NO_APP_NAME, xmlFile, args);<a name="line.331"></a>
<FONT color="green">332</FONT>            }<a name="line.332"></a>
<FONT color="green">333</FONT>            public static XmlConfig getXmlConfig(InputStream xmlFile, String[] args) throws DocumentException {<a name="line.333"></a>
<FONT color="green">334</FONT>                    return getXmlConfig(NO_APP_NAME, xmlFile, args);<a name="line.334"></a>
<FONT color="green">335</FONT>            }<a name="line.335"></a>
<FONT color="green">336</FONT>            public static XmlConfig getXmlConfig(String appName, File xmlFile, String[] args) throws DocumentException {<a name="line.336"></a>
<FONT color="green">337</FONT>                    return new XmlConfig(appName, new SAXReader().read(xmlFile), args);<a name="line.337"></a>
<FONT color="green">338</FONT>            }<a name="line.338"></a>
<FONT color="green">339</FONT>            public static XmlConfig getXmlConfig(String appName, InputStream xmlFile, String[] args) throws DocumentException {<a name="line.339"></a>
<FONT color="green">340</FONT>                    return new XmlConfig(appName, new SAXReader().read(xmlFile), args);<a name="line.340"></a>
<FONT color="green">341</FONT>            }<a name="line.341"></a>
<FONT color="green">342</FONT>    //      /**<a name="line.342"></a>
<FONT color="green">343</FONT>    //       * Returns the xml config from the system properties. If it is not stored <a name="line.343"></a>
<FONT color="green">344</FONT>    //       * there, an {@link IllegalStateException} is thrown. It can be stored in<a name="line.344"></a>
<FONT color="green">345</FONT>    //       * the system properties by calling <a name="line.345"></a>
<FONT color="green">346</FONT>    //       * {@link #putXmlConfigToSystemProperties()}.<a name="line.346"></a>
<FONT color="green">347</FONT>    //       * <a name="line.347"></a>
<FONT color="green">348</FONT>    //       * @throws IllegalStateException        if the config has not been stored using<a name="line.348"></a>
<FONT color="green">349</FONT>    //       *                                                                      putXmlConfigToSystemProperties()<a name="line.349"></a>
<FONT color="green">350</FONT>    //       */<a name="line.350"></a>
<FONT color="green">351</FONT>    //      public static XmlConfig getXmlConfigFromSystemProperties() {<a name="line.351"></a>
<FONT color="green">352</FONT>    //              final String xml = System.getProperty(SYSTEM_PROPERTY, null);<a name="line.352"></a>
<FONT color="green">353</FONT>    //              if (xml == null) {<a name="line.353"></a>
<FONT color="green">354</FONT>    //                      throw new IllegalStateException(<a name="line.354"></a>
<FONT color="green">355</FONT>    //                              "no xml config found in system properties, use putXmlConfigToSystemProperties() before accessing it"<a name="line.355"></a>
<FONT color="green">356</FONT>    //                      );<a name="line.356"></a>
<FONT color="green">357</FONT>    //              }<a name="line.357"></a>
<FONT color="green">358</FONT>    //              final Document doc;<a name="line.358"></a>
<FONT color="green">359</FONT>    //              try {<a name="line.359"></a>
<FONT color="green">360</FONT>    //                      doc = new SAXReader().read(new StringReader(xml));<a name="line.360"></a>
<FONT color="green">361</FONT>    //                      return fromXmlDocument(doc);<a name="line.361"></a>
<FONT color="green">362</FONT>    //              }<a name="line.362"></a>
<FONT color="green">363</FONT>    //              catch (Exception ex) {<a name="line.363"></a>
<FONT color="green">364</FONT>    //                      System.out.println(xml);<a name="line.364"></a>
<FONT color="green">365</FONT>    //                      throw new RuntimeException("cannot restore xml config element, e=" + ex, ex);                   <a name="line.365"></a>
<FONT color="green">366</FONT>    //              }<a name="line.366"></a>
<FONT color="green">367</FONT>    //      }<a name="line.367"></a>
<FONT color="green">368</FONT>    //      /**<a name="line.368"></a>
<FONT color="green">369</FONT>    //       * Stores the current &lt;code&gt;XmlConfig&lt;/code&gt; instance in the system <a name="line.369"></a>
<FONT color="green">370</FONT>    //       * properties under the key {@link #SYSTEM_PROPERTY}, which is the fully<a name="line.370"></a>
<FONT color="green">371</FONT>    //       * qualified class name of &lt;code&gt;XmlConfig&lt;/code&gt;.<a name="line.371"></a>
<FONT color="green">372</FONT>    //       * @throws XmlConfigException <a name="line.372"></a>
<FONT color="green">373</FONT>    //       */<a name="line.373"></a>
<FONT color="green">374</FONT>    //      public void putXmlConfigToSystemProperties() throws XmlConfigException {<a name="line.374"></a>
<FONT color="green">375</FONT>    //              staticConfig = toXmlDocument();<a name="line.375"></a>
<FONT color="green">376</FONT>    //      }<a name="line.376"></a>
<FONT color="green">377</FONT>            <a name="line.377"></a>
<FONT color="green">378</FONT>            /**<a name="line.378"></a>
<FONT color="green">379</FONT>             * Writes this xml config to the given output stream<a name="line.379"></a>
<FONT color="green">380</FONT>             */<a name="line.380"></a>
<FONT color="green">381</FONT>            public void writeTo(OutputStream out) {<a name="line.381"></a>
<FONT color="green">382</FONT>                    final Document doc = toXmlDocument();<a name="line.382"></a>
<FONT color="green">383</FONT>                    new XmlPrint().print(doc, out);<a name="line.383"></a>
<FONT color="green">384</FONT>            }<a name="line.384"></a>
<FONT color="green">385</FONT>            /**<a name="line.385"></a>
<FONT color="green">386</FONT>             * Writes this xml config to the given writer<a name="line.386"></a>
<FONT color="green">387</FONT>             */<a name="line.387"></a>
<FONT color="green">388</FONT>            public void writeTo(Writer writer) {<a name="line.388"></a>
<FONT color="green">389</FONT>                    final Document doc = toXmlDocument();<a name="line.389"></a>
<FONT color="green">390</FONT>                    new XmlPrint().print(doc, writer);<a name="line.390"></a>
<FONT color="green">391</FONT>            }<a name="line.391"></a>
<FONT color="green">392</FONT>            <a name="line.392"></a>
<FONT color="green">393</FONT>            /**<a name="line.393"></a>
<FONT color="green">394</FONT>             * Returns a copy of the underlying xml document, including main arguments <a name="line.394"></a>
<FONT color="green">395</FONT>             * if any have been specified. From the returned document, <a name="line.395"></a>
<FONT color="green">396</FONT>             */<a name="line.396"></a>
<FONT color="green">397</FONT>            public Document toXmlDocument() {<a name="line.397"></a>
<FONT color="green">398</FONT>                    final Document doc = (Document)mDocument.clone();<a name="line.398"></a>
<FONT color="green">399</FONT>                    doc.getRootElement().elements(XmlElement.application.getXmlName()).clear();<a name="line.399"></a>
<FONT color="green">400</FONT>                    final Element app = doc.getRootElement().addElement(XmlElement.application.getXmlName());<a name="line.400"></a>
<FONT color="green">401</FONT>                    app.addAttribute(XmlAttribute.name.getXmlName(), mAppName);<a name="line.401"></a>
<FONT color="green">402</FONT>                    for (String arg : mArgs) {<a name="line.402"></a>
<FONT color="green">403</FONT>                            final Element elArg = app.addElement(XmlElement.arg.getXmlName());<a name="line.403"></a>
<FONT color="green">404</FONT>                            elArg.addAttribute(XmlAttribute.value.getXmlName(), arg);<a name="line.404"></a>
<FONT color="green">405</FONT>                    }<a name="line.405"></a>
<FONT color="green">406</FONT>                    return doc;<a name="line.406"></a>
<FONT color="green">407</FONT>            }<a name="line.407"></a>
<FONT color="green">408</FONT>            <a name="line.408"></a>
<FONT color="green">409</FONT>        /**<a name="line.409"></a>
<FONT color="green">410</FONT>         * Parses the given document and returns an XmlConfig instance. Note that<a name="line.410"></a>
<FONT color="green">411</FONT>         * this document is expected to contain an application element (direct child<a name="line.411"></a>
<FONT color="green">412</FONT>         * of root element) with a name attribute and possible with arg child nodes.<a name="line.412"></a>
<FONT color="green">413</FONT>         * Such a document is usually received by calling {@link #toXmlDocument()}.<a name="line.413"></a>
<FONT color="green">414</FONT>         * <a name="line.414"></a>
<FONT color="green">415</FONT>         * @throws DocumentException        if a dom4j xml exception occurs <a name="line.415"></a>
<FONT color="green">416</FONT>         */<a name="line.416"></a>
<FONT color="green">417</FONT>        public static XmlConfig fromXmlDocument(File file) throws DocumentException {<a name="line.417"></a>
<FONT color="green">418</FONT>            return fromXmlDocument(new SAXReader().read(file));<a name="line.418"></a>
<FONT color="green">419</FONT>        }<a name="line.419"></a>
<FONT color="green">420</FONT>        /**<a name="line.420"></a>
<FONT color="green">421</FONT>         * Parses the given document and returns an XmlConfig instance. Note that<a name="line.421"></a>
<FONT color="green">422</FONT>         * this document is expected to contain an application element (direct child<a name="line.422"></a>
<FONT color="green">423</FONT>         * of root element) with a name attribute and possible with arg child nodes.<a name="line.423"></a>
<FONT color="green">424</FONT>         * Such a document is usually received by calling {@link #toXmlDocument()}.<a name="line.424"></a>
<FONT color="green">425</FONT>         * @throws DocumentException        if a dom4j xml exception occurs <a name="line.425"></a>
<FONT color="green">426</FONT>         */<a name="line.426"></a>
<FONT color="green">427</FONT>        public static XmlConfig fromXmlDocument(Reader reader) throws DocumentException {<a name="line.427"></a>
<FONT color="green">428</FONT>            return fromXmlDocument(new SAXReader().read(reader));<a name="line.428"></a>
<FONT color="green">429</FONT>        }<a name="line.429"></a>
<FONT color="green">430</FONT>            /**<a name="line.430"></a>
<FONT color="green">431</FONT>             * Parses the given document and returns an XmlConfig instance. Note that<a name="line.431"></a>
<FONT color="green">432</FONT>             * this document is expected to contain an application element (direct child<a name="line.432"></a>
<FONT color="green">433</FONT>             * of root element) with a name attribute and possible with arg child nodes.<a name="line.433"></a>
<FONT color="green">434</FONT>             * Such a document is usually received by calling {@link #toXmlDocument()}.<a name="line.434"></a>
<FONT color="green">435</FONT>             */<a name="line.435"></a>
<FONT color="green">436</FONT>            @SuppressWarnings("unchecked")<a name="line.436"></a>
<FONT color="green">437</FONT>            public static XmlConfig fromXmlDocument(Document doc) {<a name="line.437"></a>
<FONT color="green">438</FONT>                    final Element app = doc.getRootElement().element(XmlElement.application.getXmlName());<a name="line.438"></a>
<FONT color="green">439</FONT>                    final String appName = app.attributeValue(XmlAttribute.name.getXmlName());<a name="line.439"></a>
<FONT color="green">440</FONT>                    final List&lt;String&gt; args = new ArrayList&lt;String&gt;();<a name="line.440"></a>
<FONT color="green">441</FONT>                    final Iterator&lt;Element&gt; it = app.elementIterator(XmlElement.arg.getXmlName());<a name="line.441"></a>
<FONT color="green">442</FONT>                    while (it.hasNext()) {<a name="line.442"></a>
<FONT color="green">443</FONT>                            args.add(it.next().attributeValue(XmlAttribute.value.getXmlName()));<a name="line.443"></a>
<FONT color="green">444</FONT>                    }<a name="line.444"></a>
<FONT color="green">445</FONT>                    doc.remove(app);<a name="line.445"></a>
<FONT color="green">446</FONT>                    return new XmlConfig(appName, doc, args.toArray(new String[args.size()]));<a name="line.446"></a>
<FONT color="green">447</FONT>            }<a name="line.447"></a>
<FONT color="green">448</FONT>            <a name="line.448"></a>
<FONT color="green">449</FONT>            protected int getArgCount() {<a name="line.449"></a>
<FONT color="green">450</FONT>                    return mArgs.length;<a name="line.450"></a>
<FONT color="green">451</FONT>            }<a name="line.451"></a>
<FONT color="green">452</FONT>            protected String getArg(int index) {<a name="line.452"></a>
<FONT color="green">453</FONT>                    return mArgs[index];<a name="line.453"></a>
<FONT color="green">454</FONT>            }<a name="line.454"></a>
<FONT color="green">455</FONT>            /**<a name="line.455"></a>
<FONT color="green">456</FONT>             * Returns a copy of the command line argument array<a name="line.456"></a>
<FONT color="green">457</FONT>             */<a name="line.457"></a>
<FONT color="green">458</FONT>            public String[] getArgs() {<a name="line.458"></a>
<FONT color="green">459</FONT>                    final String[] copy = new String[mArgs.length];<a name="line.459"></a>
<FONT color="green">460</FONT>                    System.arraycopy(mArgs, 0, copy, 0, copy.length);<a name="line.460"></a>
<FONT color="green">461</FONT>                    return copy;<a name="line.461"></a>
<FONT color="green">462</FONT>            }<a name="line.462"></a>
<FONT color="green">463</FONT>            <a name="line.463"></a>
<FONT color="green">464</FONT>            protected Element getRootElement() {<a name="line.464"></a>
<FONT color="green">465</FONT>                    return mDocument.getRootElement();<a name="line.465"></a>
<FONT color="green">466</FONT>            }<a name="line.466"></a>
<FONT color="green">467</FONT>            public String getAppName() {<a name="line.467"></a>
<FONT color="green">468</FONT>                    return mAppName;<a name="line.468"></a>
<FONT color="green">469</FONT>            }<a name="line.469"></a>
<FONT color="green">470</FONT>            public void setAppName(String appName) {<a name="line.470"></a>
<FONT color="green">471</FONT>                    mAppName = appName;<a name="line.471"></a>
<FONT color="green">472</FONT>            }<a name="line.472"></a>
<FONT color="green">473</FONT>            <a name="line.473"></a>
<FONT color="green">474</FONT>            public void setDefaultConfigName(String name) {<a name="line.474"></a>
<FONT color="green">475</FONT>                    getRootElement().addAttribute(XmlAttribute.def.getXmlName(), name);<a name="line.475"></a>
<FONT color="green">476</FONT>            }<a name="line.476"></a>
<FONT color="green">477</FONT>            public String getDefaultConfigName() {<a name="line.477"></a>
<FONT color="green">478</FONT>                    return getRootElement().attributeValue(XmlAttribute.def.getXmlName());<a name="line.478"></a>
<FONT color="green">479</FONT>            }<a name="line.479"></a>
<FONT color="green">480</FONT>            public Document getDefaultConfigDocument() throws XmlConfigException {<a name="line.480"></a>
<FONT color="green">481</FONT>                    return getConfigDocument(getDefaultConfigName());<a name="line.481"></a>
<FONT color="green">482</FONT>            }<a name="line.482"></a>
<FONT color="green">483</FONT>            public Element getDefaultConfigElement() throws XmlConfigException {<a name="line.483"></a>
<FONT color="green">484</FONT>                    return getConfigElement(getDefaultConfigName());<a name="line.484"></a>
<FONT color="green">485</FONT>            }<a name="line.485"></a>
<FONT color="green">486</FONT>            public Element getConfigElement(String name) throws XmlConfigException {<a name="line.486"></a>
<FONT color="green">487</FONT>                    final Document doc = getConfigDocument(name);<a name="line.487"></a>
<FONT color="green">488</FONT>                    final Element root = doc.getRootElement();<a name="line.488"></a>
<FONT color="green">489</FONT>                    return XmlUtil.getRequiredSingleChildElement(root, XmlElement.config);          <a name="line.489"></a>
<FONT color="green">490</FONT>            }<a name="line.490"></a>
<FONT color="green">491</FONT>            @SuppressWarnings("unchecked")<a name="line.491"></a>
<FONT color="green">492</FONT>            public Document getConfigDocument(String name) throws XmlConfigException {<a name="line.492"></a>
<FONT color="green">493</FONT>                    if (name == null) throw new NullPointerException("name argument is required");<a name="line.493"></a>
<FONT color="green">494</FONT>                    Iterator&lt;Element&gt; it = getRootElement().elementIterator(XmlElement.config.getXmlName());<a name="line.494"></a>
<FONT color="green">495</FONT>                    while (it.hasNext()) {<a name="line.495"></a>
<FONT color="green">496</FONT>                            Element cfg             = it.next();<a name="line.496"></a>
<FONT color="green">497</FONT>                            String cfgName  = cfg.attributeValue(XmlAttribute.name.getXmlName());<a name="line.497"></a>
<FONT color="green">498</FONT>                            if (name.equals(cfgName)) {<a name="line.498"></a>
<FONT color="green">499</FONT>                                    final Element copy = cfg.createCopy();<a name="line.499"></a>
<FONT color="green">500</FONT>                                    List&lt;Element&gt; resolved = resolve(copy, XmlUtil.getElementPath(copy, false /*recurseParents*/));<a name="line.500"></a>
<FONT color="green">501</FONT>                                    if (resolved.size() != 1) {<a name="line.501"></a>
<FONT color="green">502</FONT>                                            throw new XmlConfigException("resolved config not unique", cfg);<a name="line.502"></a>
<FONT color="green">503</FONT>                                    }<a name="line.503"></a>
<FONT color="green">504</FONT>                                    return createDocument(resolved.get(0), name);<a name="line.504"></a>
<FONT color="green">505</FONT>                            }<a name="line.505"></a>
<FONT color="green">506</FONT>                    }<a name="line.506"></a>
<FONT color="green">507</FONT>                    throw new IllegalArgumentException("no such config: " + name);<a name="line.507"></a>
<FONT color="green">508</FONT>            }<a name="line.508"></a>
<FONT color="green">509</FONT>            private static Document createDocument(Element configElement, String configName) {<a name="line.509"></a>
<FONT color="green">510</FONT>                    final Document doc = DocumentHelper.createDocument();<a name="line.510"></a>
<FONT color="green">511</FONT>                    final Element configList = DocumentHelper.createElement(XmlElement.config_list.getXmlName());<a name="line.511"></a>
<FONT color="green">512</FONT>                    configElement.addAttribute(XmlAttribute.name.getXmlName(), configName);<a name="line.512"></a>
<FONT color="green">513</FONT>                    configList.addAttribute(XmlAttribute.def.getXmlName(), configName);                             <a name="line.513"></a>
<FONT color="green">514</FONT>                    configList.add(configElement);<a name="line.514"></a>
<FONT color="green">515</FONT>                    doc.setRootElement(configList);<a name="line.515"></a>
<FONT color="green">516</FONT>                    return doc;<a name="line.516"></a>
<FONT color="green">517</FONT>            }<a name="line.517"></a>
<FONT color="green">518</FONT>            <a name="line.518"></a>
<FONT color="green">519</FONT>            protected List&lt;Element&gt; resolve(Iterator&lt;Element&gt; elementIterator, String path) throws XmlConfigException {<a name="line.519"></a>
<FONT color="green">520</FONT>                    final List&lt;Element&gt; resolved = new ArrayList&lt;Element&gt;();<a name="line.520"></a>
<FONT color="green">521</FONT>                    while (elementIterator.hasNext()) {<a name="line.521"></a>
<FONT color="green">522</FONT>                            final Element child = elementIterator.next();<a name="line.522"></a>
<FONT color="green">523</FONT>                            final String childPath = path == null ?<a name="line.523"></a>
<FONT color="green">524</FONT>                                    XmlUtil.getElementPath(child, true /*recurseParents*/) :<a name="line.524"></a>
<FONT color="green">525</FONT>                                    path + "/" + XmlUtil.getElementPath(child, false /*recurseParents*/);<a name="line.525"></a>
<FONT color="green">526</FONT>                            resolved.addAll(resolve(child, childPath));<a name="line.526"></a>
<FONT color="green">527</FONT>                    }<a name="line.527"></a>
<FONT color="green">528</FONT>                    return resolved;<a name="line.528"></a>
<FONT color="green">529</FONT>            }<a name="line.529"></a>
<FONT color="green">530</FONT>            @SuppressWarnings("unchecked")<a name="line.530"></a>
<FONT color="green">531</FONT>            protected List&lt;Element&gt; resolve(Element element, String path) throws XmlConfigException {<a name="line.531"></a>
<FONT color="green">532</FONT>                    final List&lt;Element&gt; resolved = new ArrayList&lt;Element&gt;();<a name="line.532"></a>
<FONT color="green">533</FONT>                    Attribute refAtt = element.attribute(XmlAttribute.ref.getXmlName());<a name="line.533"></a>
<FONT color="green">534</FONT>                    if (refAtt == null) {<a name="line.534"></a>
<FONT color="green">535</FONT>                            resolved.add(element);<a name="line.535"></a>
<FONT color="green">536</FONT>                    }<a name="line.536"></a>
<FONT color="green">537</FONT>                    else {<a name="line.537"></a>
<FONT color="green">538</FONT>                            resolveAttributeValue(refAtt, path);<a name="line.538"></a>
<FONT color="green">539</FONT>                            List&lt;Element&gt; refElCont = getReferredElementContent(refAtt.getValue(), path);<a name="line.539"></a>
<FONT color="green">540</FONT>                            for (final Element el : refElCont) {<a name="line.540"></a>
<FONT color="green">541</FONT>                                    final Element newEl = el.createCopy();<a name="line.541"></a>
<FONT color="green">542</FONT>                                    element.getParent().add(newEl);<a name="line.542"></a>
<FONT color="green">543</FONT>                                    resolved.addAll(resolve(newEl, XmlUtil.getElementPath(el, true/*recurseParents*/)));<a name="line.543"></a>
<FONT color="green">544</FONT>                            }<a name="line.544"></a>
<FONT color="green">545</FONT>                            if (!element.getParent().remove(element)) {<a name="line.545"></a>
<FONT color="green">546</FONT>                                    throw new RuntimeException("internal error: should have been removed");<a name="line.546"></a>
<FONT color="green">547</FONT>                            }<a name="line.547"></a>
<FONT color="green">548</FONT>                    }<a name="line.548"></a>
<FONT color="green">549</FONT>                    <a name="line.549"></a>
<FONT color="green">550</FONT>                    for (Element elem : resolved) {<a name="line.550"></a>
<FONT color="green">551</FONT>                            Iterator&lt;Attribute&gt; itA = elem.attributeIterator();<a name="line.551"></a>
<FONT color="green">552</FONT>                            while (itA.hasNext()) {<a name="line.552"></a>
<FONT color="green">553</FONT>                                    Attribute att = itA.next();<a name="line.553"></a>
<FONT color="green">554</FONT>                                    resolveAttributeValue(att, path);<a name="line.554"></a>
<FONT color="green">555</FONT>                            }<a name="line.555"></a>
<FONT color="green">556</FONT>                            <a name="line.556"></a>
<FONT color="green">557</FONT>    //                      resolve(elem.elementIterator(), path);<a name="line.557"></a>
<FONT color="green">558</FONT>                            Iterator&lt;Element&gt; itE = elem.elementIterator();<a name="line.558"></a>
<FONT color="green">559</FONT>                            while (itE.hasNext()) {<a name="line.559"></a>
<FONT color="green">560</FONT>                                    Element child = itE.next();<a name="line.560"></a>
<FONT color="green">561</FONT>                                    resolve(child, path + "/" + XmlUtil.getElementPath(child, false /*recurseParents*/));<a name="line.561"></a>
<FONT color="green">562</FONT>                            }<a name="line.562"></a>
<FONT color="green">563</FONT>                            if (elem.attribute(XmlAttribute.ref.getXmlName()) != null) {<a name="line.563"></a>
<FONT color="green">564</FONT>                                    throw new RuntimeException("internal error: should have been resolved");<a name="line.564"></a>
<FONT color="green">565</FONT>                            }<a name="line.565"></a>
<FONT color="green">566</FONT>                    }<a name="line.566"></a>
<FONT color="green">567</FONT>                    return resolved;<a name="line.567"></a>
<FONT color="green">568</FONT>            }<a name="line.568"></a>
<FONT color="green">569</FONT>            <a name="line.569"></a>
<FONT color="green">570</FONT>            protected void resolveAttributeValue(Attribute att, String path) throws XmlConfigException {<a name="line.570"></a>
<FONT color="green">571</FONT>                    int start;<a name="line.571"></a>
<FONT color="green">572</FONT>                    int end = -1;<a name="line.572"></a>
<FONT color="green">573</FONT>                                    <a name="line.573"></a>
<FONT color="green">574</FONT>                    String value    = att.getValue();<a name="line.574"></a>
<FONT color="green">575</FONT>                    String resValue = "";<a name="line.575"></a>
<FONT color="green">576</FONT>                    while ((start = value.indexOf("${", end + 1)) != -1) {<a name="line.576"></a>
<FONT color="green">577</FONT>                            resValue += value.substring(end + 1, start);<a name="line.577"></a>
<FONT color="green">578</FONT>                            end = value.indexOf('}', start + 2);<a name="line.578"></a>
<FONT color="green">579</FONT>                            if (end == -1) {<a name="line.579"></a>
<FONT color="green">580</FONT>                                    throw new XmlConfigException("closing } missing for attribute \"" + att.getName() + "=" + value + "\"", path);<a name="line.580"></a>
<FONT color="green">581</FONT>                            }<a name="line.581"></a>
<FONT color="green">582</FONT>                            resValue += getResolvedAttributeValue(att, path, value.substring(start + 2, end));<a name="line.582"></a>
<FONT color="green">583</FONT>                    }<a name="line.583"></a>
<FONT color="green">584</FONT>                    resValue += value.substring(end + 1, value.length());<a name="line.584"></a>
<FONT color="green">585</FONT>                    att.setValue(resValue);<a name="line.585"></a>
<FONT color="green">586</FONT>            }<a name="line.586"></a>
<FONT color="green">587</FONT>    <a name="line.587"></a>
<FONT color="green">588</FONT>            protected String getResolvedAttributeValue(Attribute att, String path, String resolveKey) throws XmlConfigException {<a name="line.588"></a>
<FONT color="green">589</FONT>                    for (ResolveKey key : ResolveKey.values()) {<a name="line.589"></a>
<FONT color="green">590</FONT>                            if (key.matches(resolveKey)) {<a name="line.590"></a>
<FONT color="green">591</FONT>                                    return key.resolve(att, path, resolveKey, this);<a name="line.591"></a>
<FONT color="green">592</FONT>                            }<a name="line.592"></a>
<FONT color="green">593</FONT>                    }<a name="line.593"></a>
<FONT color="green">594</FONT>                    throw new XmlConfigException("cannot resolve '" + resolveKey + "' for attribute \"" + att.getName() + "=" + att.getValue() + "\"", path);               <a name="line.594"></a>
<FONT color="green">595</FONT>            }<a name="line.595"></a>
<FONT color="green">596</FONT>    <a name="line.596"></a>
<FONT color="green">597</FONT>            @SuppressWarnings("unchecked")<a name="line.597"></a>
<FONT color="green">598</FONT>            protected List&lt;Element&gt; getReferredElementContent(String name, String path) throws XmlConfigException, MissingReferableException {<a name="line.598"></a>
<FONT color="green">599</FONT>                    Iterator&lt;Element&gt; it = getRootElement().elementIterator(XmlElement.referable.getXmlName());<a name="line.599"></a>
<FONT color="green">600</FONT>                    while (it.hasNext()) {<a name="line.600"></a>
<FONT color="green">601</FONT>                            Element ref = it.next();<a name="line.601"></a>
<FONT color="green">602</FONT>                            String refName = ref.attributeValue(XmlAttribute.name.getXmlName());<a name="line.602"></a>
<FONT color="green">603</FONT>                            if (name.equals(refName)) {<a name="line.603"></a>
<FONT color="green">604</FONT>                                    return ref.elements();<a name="line.604"></a>
<FONT color="green">605</FONT>                            }<a name="line.605"></a>
<FONT color="green">606</FONT>                    }<a name="line.606"></a>
<FONT color="green">607</FONT>                    throw new MissingReferableException(name, "cannot find referred element '" + name + "'", path);<a name="line.607"></a>
<FONT color="green">608</FONT>            }<a name="line.608"></a>
<FONT color="green">609</FONT>                    <a name="line.609"></a>
<FONT color="green">610</FONT>            /**<a name="line.610"></a>
<FONT color="green">611</FONT>             * Initializes the log manager configuration with logging configuration from<a name="line.611"></a>
<FONT color="green">612</FONT>             * the the {@link #getDefaultConfigDocument() default config}. Calls<a name="line.612"></a>
<FONT color="green">613</FONT>             * {@link LogManager#readConfiguration(InputStream)} with <a name="line.613"></a>
<FONT color="green">614</FONT>             * properties read from the &lt;tt&gt;logging&lt;/tt&gt; element.<a name="line.614"></a>
<FONT color="green">615</FONT>             * &lt;p&gt;<a name="line.615"></a>
<FONT color="green">616</FONT>             * The logging element is expected to look like this:<a name="line.616"></a>
<FONT color="green">617</FONT>             * &lt;pre&gt;<a name="line.617"></a>
<FONT color="green">618</FONT>                    &lt;logging&gt;<a name="line.618"></a>
<FONT color="green">619</FONT>                            &lt;prop name=".level"  value="INFO"/&gt;       <a name="line.619"></a>
<FONT color="green">620</FONT>                            &lt;prop name="handlers"        value="ch.javasoft.util.logging.StandardOutHandler,ch.javasoft.util.logging.StandardErrHandler"/&gt;<a name="line.620"></a>
<FONT color="green">621</FONT>                            ...<a name="line.621"></a>
<FONT color="green">622</FONT>                    &lt;/logging&gt;<a name="line.622"></a>
<FONT color="green">623</FONT>             * &lt;/pre&gt;<a name="line.623"></a>
<FONT color="green">624</FONT>             * <a name="line.624"></a>
<FONT color="green">625</FONT>             * @throws XmlConfigException   if an xml configuration error occurs<a name="line.625"></a>
<FONT color="green">626</FONT>             */<a name="line.626"></a>
<FONT color="green">627</FONT>            public void initLogManagerConfiguration() throws XmlConfigException {<a name="line.627"></a>
<FONT color="green">628</FONT>                    initLogManagerConfiguration(getDefaultConfigElement());<a name="line.628"></a>
<FONT color="green">629</FONT>            }<a name="line.629"></a>
<FONT color="green">630</FONT>            /**<a name="line.630"></a>
<FONT color="green">631</FONT>             * Initializes the log manager configuration with logging configuration from<a name="line.631"></a>
<FONT color="green">632</FONT>             * the the specified {@link #getConfigDocument(String) config}. Calls<a name="line.632"></a>
<FONT color="green">633</FONT>             * {@link LogManager#readConfiguration(InputStream)} with <a name="line.633"></a>
<FONT color="green">634</FONT>             * properties read from the &lt;tt&gt;logging&lt;/tt&gt; element.<a name="line.634"></a>
<FONT color="green">635</FONT>             * &lt;p&gt;<a name="line.635"></a>
<FONT color="green">636</FONT>             * The logging element is expected to look like this:<a name="line.636"></a>
<FONT color="green">637</FONT>             * &lt;pre&gt;<a name="line.637"></a>
<FONT color="green">638</FONT>                    &lt;logging&gt;<a name="line.638"></a>
<FONT color="green">639</FONT>                            &lt;prop name=".level"  value="INFO"/&gt;       <a name="line.639"></a>
<FONT color="green">640</FONT>                            &lt;prop name="handlers"        value="ch.javasoft.util.logging.StandardOutHandler,ch.javasoft.util.logging.StandardErrHandler"/&gt;<a name="line.640"></a>
<FONT color="green">641</FONT>                            ...<a name="line.641"></a>
<FONT color="green">642</FONT>                    &lt;/logging&gt;<a name="line.642"></a>
<FONT color="green">643</FONT>             * &lt;/pre&gt;<a name="line.643"></a>
<FONT color="green">644</FONT>             * <a name="line.644"></a>
<FONT color="green">645</FONT>             * @param configName                    the config to use, corresponds to <a name="line.645"></a>
<FONT color="green">646</FONT>             *                                                              {@link #getConfigDocument(String)}<a name="line.646"></a>
<FONT color="green">647</FONT>             * @throws XmlConfigException   if an xml configuration error occurs<a name="line.647"></a>
<FONT color="green">648</FONT>             */<a name="line.648"></a>
<FONT color="green">649</FONT>            public void initLogManagerConfiguration(String configName) throws XmlConfigException {<a name="line.649"></a>
<FONT color="green">650</FONT>                    initLogManagerConfiguration(getConfigElement(configName));<a name="line.650"></a>
<FONT color="green">651</FONT>            }<a name="line.651"></a>
<FONT color="green">652</FONT>            /**<a name="line.652"></a>
<FONT color="green">653</FONT>             * Returns the logging properties read from the &lt;tt&gt;logging&lt;/tt&gt; element, or<a name="line.653"></a>
<FONT color="green">654</FONT>             * &lt;code&gt;null&lt;/code&gt; if no logging properties found in the xml config.<a name="line.654"></a>
<FONT color="green">655</FONT>             * &lt;p&gt;<a name="line.655"></a>
<FONT color="green">656</FONT>             * The logging element is expected to look like this:<a name="line.656"></a>
<FONT color="green">657</FONT>             * &lt;pre&gt;<a name="line.657"></a>
<FONT color="green">658</FONT>                    &lt;logging&gt;<a name="line.658"></a>
<FONT color="green">659</FONT>                            &lt;prop name=".level"  value="INFO"/&gt;       <a name="line.659"></a>
<FONT color="green">660</FONT>                            &lt;prop name="handlers"        value="ch.javasoft.util.logging.StandardOutHandler,ch.javasoft.util.logging.StandardErrHandler"/&gt;<a name="line.660"></a>
<FONT color="green">661</FONT>                            ...<a name="line.661"></a>
<FONT color="green">662</FONT>                    &lt;/logging&gt;<a name="line.662"></a>
<FONT color="green">663</FONT>             * &lt;/pre&gt;<a name="line.663"></a>
<FONT color="green">664</FONT>             * <a name="line.664"></a>
<FONT color="green">665</FONT>             * @throws XmlConfigException   if an xml configuration error occurs<a name="line.665"></a>
<FONT color="green">666</FONT>             */<a name="line.666"></a>
<FONT color="green">667</FONT>            public Properties getLoggingProperties() throws XmlConfigException {<a name="line.667"></a>
<FONT color="green">668</FONT>                    return getLoggingProperties(getDefaultConfigElement());<a name="line.668"></a>
<FONT color="green">669</FONT>            }<a name="line.669"></a>
<FONT color="green">670</FONT>            /**<a name="line.670"></a>
<FONT color="green">671</FONT>             * Returns the logging properties read from the &lt;tt&gt;logging&lt;/tt&gt; element, or<a name="line.671"></a>
<FONT color="green">672</FONT>             * &lt;code&gt;null&lt;/code&gt; if no logging properties found in the xml config.<a name="line.672"></a>
<FONT color="green">673</FONT>             * &lt;p&gt;<a name="line.673"></a>
<FONT color="green">674</FONT>             * The logging element is expected to look like this:<a name="line.674"></a>
<FONT color="green">675</FONT>             * &lt;pre&gt;<a name="line.675"></a>
<FONT color="green">676</FONT>                    &lt;logging&gt;<a name="line.676"></a>
<FONT color="green">677</FONT>                            &lt;prop name=".level"  value="INFO"/&gt;       <a name="line.677"></a>
<FONT color="green">678</FONT>                            &lt;prop name="handlers"        value="ch.javasoft.util.logging.StandardOutHandler,ch.javasoft.util.logging.StandardErrHandler"/&gt;<a name="line.678"></a>
<FONT color="green">679</FONT>                            ...<a name="line.679"></a>
<FONT color="green">680</FONT>                    &lt;/logging&gt;<a name="line.680"></a>
<FONT color="green">681</FONT>             * &lt;/pre&gt;<a name="line.681"></a>
<FONT color="green">682</FONT>             * <a name="line.682"></a>
<FONT color="green">683</FONT>             * @param configName                    the config to use, corresponds to <a name="line.683"></a>
<FONT color="green">684</FONT>             *                                                              {@link #getConfigDocument(String)}<a name="line.684"></a>
<FONT color="green">685</FONT>             * @throws XmlConfigException   if an xml configuration error occurs<a name="line.685"></a>
<FONT color="green">686</FONT>             */<a name="line.686"></a>
<FONT color="green">687</FONT>            public Properties getLoggingProperties(String configName) throws XmlConfigException {<a name="line.687"></a>
<FONT color="green">688</FONT>                    return getLoggingProperties(getConfigElement(configName));<a name="line.688"></a>
<FONT color="green">689</FONT>            }<a name="line.689"></a>
<FONT color="green">690</FONT>            /**<a name="line.690"></a>
<FONT color="green">691</FONT>             * Returns the logging properties read from the &lt;tt&gt;logging&lt;/tt&gt; element, or<a name="line.691"></a>
<FONT color="green">692</FONT>             * &lt;code&gt;null&lt;/code&gt; if no logging properties found in the xml config.<a name="line.692"></a>
<FONT color="green">693</FONT>             * &lt;p&gt;<a name="line.693"></a>
<FONT color="green">694</FONT>             * The logging element is expected to look like this:<a name="line.694"></a>
<FONT color="green">695</FONT>             * &lt;pre&gt;<a name="line.695"></a>
<FONT color="green">696</FONT>                    &lt;logging&gt;<a name="line.696"></a>
<FONT color="green">697</FONT>                            &lt;prop name=".level"  value="INFO"/&gt;       <a name="line.697"></a>
<FONT color="green">698</FONT>                            &lt;prop name="handlers"        value="ch.javasoft.util.logging.StandardOutHandler,ch.javasoft.util.logging.StandardErrHandler"/&gt;<a name="line.698"></a>
<FONT color="green">699</FONT>                            ...<a name="line.699"></a>
<FONT color="green">700</FONT>                    &lt;/logging&gt;<a name="line.700"></a>
<FONT color="green">701</FONT>             * &lt;/pre&gt;<a name="line.701"></a>
<FONT color="green">702</FONT>             * <a name="line.702"></a>
<FONT color="green">703</FONT>             * @param config                                the config element to use<a name="line.703"></a>
<FONT color="green">704</FONT>             * @throws XmlConfigException   if an xml configuration error occurs<a name="line.704"></a>
<FONT color="green">705</FONT>             */<a name="line.705"></a>
<FONT color="green">706</FONT>            @SuppressWarnings("unchecked")<a name="line.706"></a>
<FONT color="green">707</FONT>            private Properties getLoggingProperties(Element config) throws XmlConfigException {<a name="line.707"></a>
<FONT color="green">708</FONT>                    final Element logging = XmlUtil.getOptionalSingleChildElement(config, XmlElement.logging);<a name="line.708"></a>
<FONT color="green">709</FONT>                    final List&lt;Element&gt; props = (List&lt;Element&gt;)logging.elements(XmlElement.property.getXmlName());<a name="line.709"></a>
<FONT color="green">710</FONT>                    <a name="line.710"></a>
<FONT color="green">711</FONT>                    if (props != null) {<a name="line.711"></a>
<FONT color="green">712</FONT>                            final Properties loggingProps = new Properties();<a name="line.712"></a>
<FONT color="green">713</FONT>                            for (final Element property : props) {<a name="line.713"></a>
<FONT color="green">714</FONT>                                    String path = XmlUtil.getElementPath(property, true /*recurseParents*/);<a name="line.714"></a>
<FONT color="green">715</FONT>                                    <a name="line.715"></a>
<FONT color="green">716</FONT>                                    final Attribute attRef = property.attribute(XmlAttribute.ref.getXmlName());<a name="line.716"></a>
<FONT color="green">717</FONT>                                    final Iterable&lt;Element&gt; resolved; <a name="line.717"></a>
<FONT color="green">718</FONT>                                    if (attRef != null) {<a name="line.718"></a>
<FONT color="green">719</FONT>                                            resolved = resolve(property, path);<a name="line.719"></a>
<FONT color="green">720</FONT>                                    }<a name="line.720"></a>
<FONT color="green">721</FONT>                                    else {<a name="line.721"></a>
<FONT color="green">722</FONT>                                            resolved = Collections.singleton(property);<a name="line.722"></a>
<FONT color="green">723</FONT>                                    }<a name="line.723"></a>
<FONT color="green">724</FONT>                                    for (Element prop : resolved) {<a name="line.724"></a>
<FONT color="green">725</FONT>                                            final Attribute attName         = prop.attribute(XmlAttribute.name.getXmlName()); <a name="line.725"></a>
<FONT color="green">726</FONT>                                            final Attribute attValue        = prop.attribute(XmlAttribute.value.getXmlName());<a name="line.726"></a>
<FONT color="green">727</FONT>                                            if (attName == null) {<a name="line.727"></a>
<FONT color="green">728</FONT>                                                    throw new XmlConfigException("name attribute missing", path);<a name="line.728"></a>
<FONT color="green">729</FONT>                                            }<a name="line.729"></a>
<FONT color="green">730</FONT>                                            resolveAttributeValue(attName, path);<a name="line.730"></a>
<FONT color="green">731</FONT>                                            final String name = XmlUtil.getRequiredAttributeValue(prop, XmlAttribute.name); <a name="line.731"></a>
<FONT color="green">732</FONT>                                            path += "[name=" + name + "]";<a name="line.732"></a>
<FONT color="green">733</FONT>                                            resolveAttributeValue(attValue, path);<a name="line.733"></a>
<FONT color="green">734</FONT>                                            final String value      = XmlUtil.getRequiredAttributeValue(prop, XmlAttribute.value); <a name="line.734"></a>
<FONT color="green">735</FONT>                                            loggingProps.put(name, value);<a name="line.735"></a>
<FONT color="green">736</FONT>                                    }<a name="line.736"></a>
<FONT color="green">737</FONT>                            }<a name="line.737"></a>
<FONT color="green">738</FONT>                            return loggingProps;<a name="line.738"></a>
<FONT color="green">739</FONT>                    }<a name="line.739"></a>
<FONT color="green">740</FONT>                    return null;<a name="line.740"></a>
<FONT color="green">741</FONT>            }<a name="line.741"></a>
<FONT color="green">742</FONT>            /**<a name="line.742"></a>
<FONT color="green">743</FONT>             * Initializes the log manager configuration with logging configuration from<a name="line.743"></a>
<FONT color="green">744</FONT>             * the the given element. Calls<a name="line.744"></a>
<FONT color="green">745</FONT>             * {@link LogManager#readConfiguration(InputStream)} with <a name="line.745"></a>
<FONT color="green">746</FONT>             * properties read from the &lt;tt&gt;logging&lt;/tt&gt; child element of <a name="line.746"></a>
<FONT color="green">747</FONT>             * &lt;tt&gt;config&lt;/tt&gt;.<a name="line.747"></a>
<FONT color="green">748</FONT>             * &lt;p&gt;<a name="line.748"></a>
<FONT color="green">749</FONT>             * The logging element is expected to look like this:<a name="line.749"></a>
<FONT color="green">750</FONT>             * &lt;pre&gt;<a name="line.750"></a>
<FONT color="green">751</FONT>                    &lt;logging&gt;<a name="line.751"></a>
<FONT color="green">752</FONT>                            &lt;prop name=".level"  value="INFO"/&gt;       <a name="line.752"></a>
<FONT color="green">753</FONT>                            &lt;prop name="handlers"        value="ch.javasoft.util.logging.StandardOutHandler,ch.javasoft.util.logging.StandardErrHandler"/&gt;<a name="line.753"></a>
<FONT color="green">754</FONT>                            ...<a name="line.754"></a>
<FONT color="green">755</FONT>                    &lt;/logging&gt;<a name="line.755"></a>
<FONT color="green">756</FONT>             * &lt;/pre&gt;<a name="line.756"></a>
<FONT color="green">757</FONT>             * <a name="line.757"></a>
<FONT color="green">758</FONT>             * @param config                                the config element, which contains the<a name="line.758"></a>
<FONT color="green">759</FONT>             *                                                              logging child element<a name="line.759"></a>
<FONT color="green">760</FONT>             * @throws XmlConfigException   if an xml configuration error occurs<a name="line.760"></a>
<FONT color="green">761</FONT>             */<a name="line.761"></a>
<FONT color="green">762</FONT>            private void initLogManagerConfiguration(Element config) throws XmlConfigException {<a name="line.762"></a>
<FONT color="green">763</FONT>                    final Properties loggingProps = getLoggingProperties(config);<a name="line.763"></a>
<FONT color="green">764</FONT>                    <a name="line.764"></a>
<FONT color="green">765</FONT>                    if (loggingProps != null) {<a name="line.765"></a>
<FONT color="green">766</FONT>                            final ByteArrayOutputStream buf = new ByteArrayOutputStream();<a name="line.766"></a>
<FONT color="green">767</FONT>                            try {<a name="line.767"></a>
<FONT color="green">768</FONT>                                    final String msg = "logging properties from xml-config: " + XmlUtil.getElementPath(config, true /*recurse parents*/);<a name="line.768"></a>
<FONT color="green">769</FONT>                                    loggingProps.store(buf, msg);<a name="line.769"></a>
<FONT color="green">770</FONT>                                    final ByteArrayInputStream in = new ByteArrayInputStream(buf.toByteArray());<a name="line.770"></a>
<FONT color="green">771</FONT>                                    LogManager.getLogManager().readConfiguration(in);<a name="line.771"></a>
<FONT color="green">772</FONT>                                    Logger.getLogger(getClass().getSimpleName()).info("initialized logging properties from xml-config");<a name="line.772"></a>
<FONT color="green">773</FONT>                            }<a name="line.773"></a>
<FONT color="green">774</FONT>                            catch (Exception ex) {<a name="line.774"></a>
<FONT color="green">775</FONT>                                    throw new XmlConfigException("cannot set logging config, e=" + ex, config);<a name="line.775"></a>
<FONT color="green">776</FONT>                            }<a name="line.776"></a>
<FONT color="green">777</FONT>                    }<a name="line.777"></a>
<FONT color="green">778</FONT>            }<a name="line.778"></a>
<FONT color="green">779</FONT>            @SuppressWarnings("unchecked")<a name="line.779"></a>
<FONT color="green">780</FONT>            public void printUsage(PrintStream stream, String usageName) throws XmlConfigException {<a name="line.780"></a>
<FONT color="green">781</FONT>                    Element element = XmlUtil.getChildElementByAttributeValue(getRootElement(), XmlElement.usage, XmlAttribute.name, usageName, true /*throwExceptionIfNull*/);<a name="line.781"></a>
<FONT color="green">782</FONT>                    printUsageLines(stream, element.elementIterator());<a name="line.782"></a>
<FONT color="green">783</FONT>            }<a name="line.783"></a>
<FONT color="green">784</FONT>            @SuppressWarnings("unchecked")<a name="line.784"></a>
<FONT color="green">785</FONT>            private void printUsageLines(PrintStream stream, Iterator&lt;Element&gt; usageChildIt) throws XmlConfigException {<a name="line.785"></a>
<FONT color="green">786</FONT>                    while (usageChildIt.hasNext()) {<a name="line.786"></a>
<FONT color="green">787</FONT>                            Element el = usageChildIt.next();<a name="line.787"></a>
<FONT color="green">788</FONT>                            if (XmlUtil.isExpectedElementName(el, XmlElement.line)) {<a name="line.788"></a>
<FONT color="green">789</FONT>                                    Element copy = el.createCopy();<a name="line.789"></a>
<FONT color="green">790</FONT>                                    List&lt;Element&gt; res = resolve(copy, XmlUtil.getElementPath(copy, true /*recurseParents*/));<a name="line.790"></a>
<FONT color="green">791</FONT>                                    for (Element r : res) {<a name="line.791"></a>
<FONT color="green">792</FONT>                                            stream.println(r.attributeValue(XmlAttribute.value.getXmlName()));<a name="line.792"></a>
<FONT color="green">793</FONT>                                    }<a name="line.793"></a>
<FONT color="green">794</FONT>                            }<a name="line.794"></a>
<FONT color="green">795</FONT>                            else if (XmlUtil.isExpectedElementName(el, XmlElement.usage)) {<a name="line.795"></a>
<FONT color="green">796</FONT>                                    Element parentCopy = el.getParent().createCopy();<a name="line.796"></a>
<FONT color="green">797</FONT>                                    Element copy = el.createCopy();<a name="line.797"></a>
<FONT color="green">798</FONT>                                    parentCopy.add(copy);<a name="line.798"></a>
<FONT color="green">799</FONT>                                    List&lt;Element&gt; res = resolve(copy, XmlUtil.getElementPath(copy, true /*recurseParents*/));<a name="line.799"></a>
<FONT color="green">800</FONT>                                    for (Element r : res) {<a name="line.800"></a>
<FONT color="green">801</FONT>                                            printUsageLines(stream, r.elementIterator());<a name="line.801"></a>
<FONT color="green">802</FONT>                                    }<a name="line.802"></a>
<FONT color="green">803</FONT>                            }<a name="line.803"></a>
<FONT color="green">804</FONT>                            <a name="line.804"></a>
<FONT color="green">805</FONT>                    }<a name="line.805"></a>
<FONT color="green">806</FONT>            }<a name="line.806"></a>
<FONT color="green">807</FONT>            <a name="line.807"></a>
<FONT color="green">808</FONT>    }<a name="line.808"></a>




























































</PRE>
</BODY>
</HTML>
